--- asterisk/apps/app_voicemail.c.ORIG	2006-01-10 17:01:21.000000000 -0600
+++ asterisk/apps/app_voicemail.c	2006-01-10 17:11:51.000000000 -0600
@@ -5650,9 +5650,11 @@
 	char *options = NULL;
 	int silent = 0;
 	int res = -1;
+	int skipuser = 0;
 
 	LOCAL_USER_ADD(u);
 	
+	*mailbox = '\0';
 	if (s) {
 		s = ast_strdupa(s);
 		if (!s) {
@@ -5665,6 +5667,8 @@
 			s = user;
 			user = strsep(&s, "@");
 			context = strsep(&s, "");
+			skipuser++;
+			ast_copy_string(mailbox, user, sizeof(mailbox));
 		}
 	}
 
@@ -5672,12 +5676,15 @@
 		silent = (strchr(options, 's')) != NULL;
 	}
 
-	if (!vm_authenticate(chan, mailbox, sizeof(mailbox), &vmus, context, NULL, 0, 3, silent)) {
+	if (!vm_authenticate(chan, mailbox, sizeof(mailbox), &vmus, context, NULL, skipuser, 3, silent)) {
 		pbx_builtin_setvar_helper(chan, "AUTH_MAILBOX", mailbox);
 		pbx_builtin_setvar_helper(chan, "AUTH_CONTEXT", vmus.context);
 		res = 0;
 	}
 
+	if (res == 0)
+		ast_play_and_wait(chan, "auth-thankyou");
+
 	LOCAL_USER_REMOVE(u);
 	return res;
 }
